import { sorted } from '../helper.esm.js';
import Options from '../Options.esm.js';

class MatchDictionary {
  constructor() {
    this.rankedDictionaries = {};
    this.rankedDictionaries = Options.rankedDictionaries;
  }

  match({
    password
  }) {
    // rankedDictionaries variable is for unit testing purposes
    const matches = [];
    const passwordLength = password.length;
    const passwordLower = password.toLowerCase();
    Object.keys(this.rankedDictionaries).forEach(dictionaryName => {
      const rankedDict = this.rankedDictionaries[dictionaryName];

      for (let i = 0; i < passwordLength; i += 1) {
        for (let j = i; j < passwordLength; j += 1) {
          if (passwordLower.slice(i, +j + 1 || 9e9) in rankedDict) {
            const word = passwordLower.slice(i, +j + 1 || 9e9);
            const rank = rankedDict[word]; // @ts-ignore

            matches.push({
              pattern: 'dictionary',
              i,
              j,
              token: password.slice(i, +j + 1 || 9e9),
              matchedWord: word,
              rank,
              dictionaryName: dictionaryName,
              reversed: false,
              l33t: false
            });
          }
        }
      }
    });
    return sorted(matches);
  }

}

export default MatchDictionary;
//# sourceMappingURL=Dictionary.esm.js.map
