import { sorted } from '../helper.esm.js';
import MatchDictionary from './Dictionary.esm.js';

/*
 * -------------------------------------------------------------------------------
 *  Dictionary reverse ----------------------------------------------------------------
 * -------------------------------------------------------------------------------
 */

class MatchDictionaryReverse {
  constructor() {
    this.MatchDictionary = new MatchDictionary();
  }

  match({
    password
  }) {
    const passwordReversed = password.split('').reverse().join('');
    const matches = this.MatchDictionary.match({
      password: passwordReversed
    }).map(match => ({ ...match,
      token: match.token.split('').reverse().join(''),
      reversed: true,
      // map coordinates back to original string
      i: password.length - 1 - match.j,
      j: password.length - 1 - match.i
    }));
    return sorted(matches);
  }

}

export default MatchDictionaryReverse;
//# sourceMappingURL=DictionaryReverse.esm.js.map
